Bug 1730533 (CVE-2019-12527) - CVE-2019-12527 squid: heap-based buffer overflow in HttpHeader::getAuth
Summary: CVE-2019-12527 squid: heap-based buffer overflow in HttpHeader::getAuth
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2019-12527
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1730534 1738485 1744672
Blocks: 1730537
TreeView+ depends on / blocked
 
Reported: 2019-07-17 04:22 UTC by Dhananjay Arunesh
Modified: 2019-09-29 15:16 UTC (History)
6 users (show)

Fixed In Version: squid 4.8
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-03 07:07:19 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2593 None None None 2019-09-02 10:34:22 UTC

Description Dhananjay Arunesh 2019-07-17 04:22:04 UTC
An issue was discovered in Squid 4.0.23 through 4.7. When checking Basic
Authentication with HttpHeader::getAuth, Squid uses a global buffer to store the
decoded data. Squid does not check that the decoded length isn't greater than
the buffer, leading to a heap-based buffer overflow with user controlled data.

Reference:
https://github.com/squid-cache/squid/commits/v4
http://www.squid-cache.org/Versions/v4/changesets/

Upstream Patch:
http://www.squid-cache.org/Versions/v4/changesets/squid-4-7f73e9c5d17664b882ed32590e6af310c247f320.patch

Comment 1 Dhananjay Arunesh 2019-07-17 04:22:21 UTC
Created squid tracking bugs for this issue:

Affects: fedora-all [bug 1730534]

Comment 2 Dhananjay Arunesh 2019-07-17 04:23:02 UTC
External References:

http://www.squid-cache.org/Advisories/SQUID-2019_5.txt

Comment 4 Cedric Buissart 🐶 2019-08-07 14:09:25 UTC
Mitigation:

Deny ftp:// protocol URLs being proxied and Cache Manager report access to all clients:

    acl FTP proto FTP
    http_access deny FTP
    http_access deny manager

Comment 8 errata-xmlrpc 2019-09-02 10:34:21 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2019:2593 https://access.redhat.com/errata/RHSA-2019:2593

Comment 9 Product Security DevOps Team 2019-09-03 07:07:19 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-12527


Note You need to log in before you can comment on or make changes to this bug.